import parser from '@babel/eslint-parser';
import globals from 'globals';
import { fileURLToPath } from 'url';
import gitignore from './gitignore.js';
/** Use babel as eslint parser to support more styntax and features */
const babelParser = Object.assign({ name: 'ali/babel-parser', files: ['**/*.{cjs,js,jsx,mjs}'], languageOptions: {
        parser,
        parserOptions: {
            requireConfigFile: false,
            ecmaVersion: 'latest',
            sourceType: 'module',
            ecmaFeatures: {
                globalReturn: false,
                impliedStrict: true,
                jsx: true,
            },
            babelOptions: {
                babelrc: false,
                configFile: false,
                presets: [
                    fileURLToPath(import.meta.resolve('@babel/preset-env')),
                    fileURLToPath(import.meta.resolve('@babel/preset-react')),
                ],
            },
        },
        globals: Object.assign(Object.assign({}, globals.node), globals.browser),
    } }, gitignore);
export default babelParser;
