import js from '@eslint/js';
import stylisticPlugin from '@stylistic/eslint-plugin';
import babelParser from '../configs/babel-parser.js';
import bestPractices from '../configs/best-practices.js';
import es6 from '../configs/es6.js';
import gitignore from '../configs/gitignore.js';
import possibleErrors from '../configs/possible-errors.js';
import stylistic from '../configs/stylistic.js';
import typescript from '../configs/typescript.js';
import variables from '../configs/variables.js';
import defineConfigArray from '../utils/defineConfigArray.js';
export default defineConfigArray([
    gitignore,
    js.configs.recommended,
    bestPractices,
    possibleErrors,
    stylisticPlugin.configs['disable-legacy'],
    stylistic,
    es6,
    variables,
    babelParser,
    ...typescript,
]);
